import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Product_selectionservice} from './Product_selection.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Product_selectioncardvariable } from './Product_selection_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Product_selection',
  templateUrl: './Product_selection.component.html',
  styleUrls: ['./Product_selection.component.scss']
})
export class Product_selectionComponent implements OnInit {
  cardButton = Product_selectioncardvariable.cardButton;
  cardmodeldata = Product_selectioncardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Product_selectioncardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Product_selection_formCode'
tableName = 'Product_selection';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Product_selectionservice,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button
  public insertFormAdd_to_order_Btn: FormGroup;

 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
name : [null],

manufacturer : [null],

type : [null],

product : [null],

price : [null, { updateOn: 'blur' }],

quantity : [null,[Validators.required]],




 













  }); // component_button200
// inser code start
  this.insertFormAdd_to_order_Btn = this._fb.group({
    type: 'select',
    price: 'currency',
    name: 'text',
    manufacturer: 'select',
    product: 'select',
    quantity: 'number',
    add_to_order_btn: 'text',
  });

  // insert code end

 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Product_selection_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 


this.getallmanufacturer();

this.getalltype();

this.getallproduct();








  }














 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;















    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;














    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);














      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;














  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);














      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;














  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 


selectmanufacturer ;     
getallmanufacturer() {
 this.mainService.getAllmanufacturer().subscribe(data=>{
this.selectmanufacturer = data;       
console.log(data);
},(error) => {       console.log(error);     });   }							   

selecttype ;     
getalltype() {
 this.mainService.getAlltype().subscribe(data=>{
this.selecttype = data;       
console.log(data);
},(error) => {       console.log(error);     });   }							   

selectproduct ;     
getallproduct() {
 this.mainService.getAllproduct().subscribe(data=>{
this.selectproduct = data;       
console.log(data);
},(error) => {       console.log(error);     });   }							   

//currency  field start
   formatCurrencyprice () {
    // Format the currency with two decimal places    
	this.rowSelected.price = Number(this.rowSelected.price ).toFixed(2);
    // Remove commas from the formatted currency   
	 this.rowSelected.price = this.rowSelected.price?.replace(/,/g, '');  }
  //currency  field end





// updateaction

// insert button


modalInsertAdd_to_order_Btn = false; 
goToInsertAdd_to_order_Btn() {
  this.modalInsertAdd_to_order_Btn=true;
  }
onSubmitInsertAdd_to_order_Btn() {
  console.log(this.insertFormAdd_to_order_Btn.value);
  this.submitted=true;
  if (this.insertFormAdd_to_order_Btn.invalid) {
    return;
  }
  this.onInsertAdd_to_order_Btn();
}
onInsertAdd_to_order_Btn() {
    this.modalInsertAdd_to_order_Btn=false;
   this.mainService.insertAdd_to_order_BtnProduct_selection(this.insertFormAdd_to_order_Btn.value).subscribe(data => {
     console.log('After add',data)
     if (data.status >=200 && data.status <=209) {
      this.toastr.success('Added successfully');
  }
if (data && data.id != null) {
        this.toastr.success('Added successfully');
      }  this.ngOnInit();
   },(error) => {
     console.error(error);
     if ( error.status >= 200 && error.status <= 299) {
       this.toastr.success("Update Successfully");
     } 
     if ( error.status >= 400 && error.status <= 499) {
       this.toastr.error("Update Failed");
     } 
     if ( error.status >= 500 && error.status <= 599) {
       this.toastr.error("Server Error");
     } 
     this.ngOnInit();
   });
     this.insertFormAdd_to_order_Btn.reset();
 }
//  insert buuton code end


}










